/* Created by vadim.maltsev 03.04.2017
 * jQuery Sticky Table Headers
 */
(function($) {
	'use strict';
	$.fn.extend({
		freezeTableHeader : function(options) {
			var offset      =  this.offset(), // Get the coordinates of the table at the position of the page
					th          =  this.find('th'),
					delayTimer  =  null,
					defaults    =  {
						'bgColor'   : '#eee',
						'z-index'   : '0',
						'transition': 'all 1s'
					};
			options = $.extend({}, defaults, options);
			if(th.length === 0) {
				if(!!window.console) {
					console.log('Unable to write html structure'); 
				}
			} else {
				// Add a screen scrolling event listener
				$(window).on('scroll', function() {
					if(!delayTimer) {
						delayTimer = setTimeout(function(){
							var top = Math.max(document.body.scrollTop, document.documentElement.scrollTop);

							th.css({
								'position'          : 'relative',
								'top'               : (top > offset.top) ? (top - offset.top) : 0,
								'background-color'  : options.bgColor,
								'z-index'           : options['z-index'],
								'transition'        : options.transition
							});

							delayTimer = null;
						}, 20);
					}

				});
			}
		}
	});

})(jQuery);